Perfect Team

传送门

You may have already known that a standard ICPC team consists of exactly three members. The perfect team however has more restrictions. A student can have some specialization: coder or mathematician. She/he can have no specialization, but can't have both at the same time.

So the team is considered perfect if it includes at least one coder, at least one mathematician and it consists of exactly three members.

You are a coach at a very large university and you know that cc of your students are coders, mm are mathematicians and xx have no specialization.

What is the maximum number of full perfect teams you can distribute them into?

Note that some students can be left without a team and each student can be a part of no more than one team.

You are also asked to answer qq independent queries.

Input

The first line contains a single integer qq (1≤q≤1041≤q≤104) — the number of queries.

Each of the next qq lines contains three integers cc, mm and xx (0≤c,m,x≤1080≤c,m,x≤108) — the number of coders, mathematicians and students without any specialization in the university, respectively.

Note that the no student is both coder and mathematician at the same time.

Output

Print qq integers — the ii-th of them should be the answer to the ii query in the order they are given in the input. The answer is the maximum number of full perfect teams you can distribute your students into.

Example

Input

6
1 1 1
3 6 0
0 0 0
0 1 1
10 1 10
4 4 1

Output

1
3
0
0
1
3

Note

In the first example here are how teams are formed:

  1. the only team of 1 coder, 1 mathematician and 1 without specialization;
  2. all three teams consist of 1 coder and 2 mathematicians;
  3. no teams can be formed;
  4. no teams can be formed;
  5. one team consists of 1 coder, 1 mathematician and 1 without specialization, the rest aren't able to form any team.
  6. one team consists of 1 coder, 1 mathematician and 1 without specialization, one consists of 2 coders and 1 mathematician and one consists of 1 coder and 2 mathematicians.

题解:

人家说这道题是二分,但是我比较懒,从网上看了个小规律就不用二分了。

假设三类数数目分别为x,y,z。int a=min(x,y),int b=x+y+z-a*3,则如果b>=0,队伍最大数显然就是a了。如果b<0,则最大队伍数小于a,最大队伍数为(x+y+z)/3。

#include <bits/stdc++.h>
#include <iostream>
#include <algorithm>
#include <queue>
#include <cstring>
#include <map>

using namespace std;

const int inf=0x3f3f3f;

int main()
{
//	freopen("input.txt","r",stdin);
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	
	int t;cin>>t;
	while(t--)
	{
		int x,y,z;cin>>x>>y>>z;
		int a=min(x,y);
		int b=x+y+z-3*a;
		if(b>=0) cout<<a<<endl;
		else 
		{
			cout<<(x+y+z)/3<<endl;
		}
	}
	
	return 0;
}
原创文章 99 获赞 15 访问量 7357

猜你喜欢

转载自blog.csdn.net/qq_45328552/article/details/101110924